<?php

namespace App\Modules\Trade\Pay;

use App\Modules\Product\Services\ProductService;
use App\Modules\Subscribe\Models\Order;
use App\Modules\User\Services\UserService;

/**
 * 
 * @property \App\Modules\Product\Models\Product $product
 */
class RechargeOrderPaySuccess extends PaySuccessAbstract
{

    private $product;

    public function __construct(Order $order)
    {
        parent::__construct($order);
        $this->product = ProductService::getProductSingle($order->product_id);
    }

    protected function handlePayProcess()
    {
        $total = $this->product->price * 100 + $this->product->given;
        $uid = $this->order->uid;
        UserService::addBalance($uid, $total, $this->product->price * 100, $this->product->given);
    }
}
